// Code generated by protoc-gen-connect-go. DO NOT EDIT.
//
// Source: connectrpc/rooms/v1/rooms.proto

package roomsv1connect

import (
	connect "connectrpc.com/connect"
	context "context"
	errors "errors"
	v1 "gitlab.com/binarygame/microservices/rooms/pkg/gen/connectrpc/rooms/v1"
	http "net/http"
	strings "strings"
)

// This is a compile-time assertion to ensure that this generated file and the connect package are
// compatible. If you get a compiler error that this constant is not defined, this code was
// generated with a version of connect newer than the one compiled into your binary. You can fix the
// problem by either regenerating this code with an older version of connect or updating the connect
// version compiled into your binary.
const _ = connect.IsAtLeastVersion1_13_0

const (
	// RoomsServiceName is the fully-qualified name of the RoomsService service.
	RoomsServiceName = "connectrpc.rooms.v1.RoomsService"
)

// These constants are the fully-qualified names of the RPCs defined in this package. They're
// exposed at runtime as Spec.Procedure and as the final two segments of the HTTP route.
//
// Note that these are different from the fully-qualified method names used by
// google.golang.org/protobuf/reflect/protoreflect. To convert from these constants to
// reflection-formatted method names, remove the leading slash and convert the remaining slash to a
// period.
const (
	// RoomsServiceCreateRoomProcedure is the fully-qualified name of the RoomsService's CreateRoom RPC.
	RoomsServiceCreateRoomProcedure = "/connectrpc.rooms.v1.RoomsService/CreateRoom"
	// RoomsServiceEditRoomProcedure is the fully-qualified name of the RoomsService's EditRoom RPC.
	RoomsServiceEditRoomProcedure = "/connectrpc.rooms.v1.RoomsService/EditRoom"
	// RoomsServiceRegisterUserInRoomProcedure is the fully-qualified name of the RoomsService's
	// RegisterUserInRoom RPC.
	RoomsServiceRegisterUserInRoomProcedure = "/connectrpc.rooms.v1.RoomsService/RegisterUserInRoom"
	// RoomsServiceRemoveUserFromRoomProcedure is the fully-qualified name of the RoomsService's
	// RemoveUserFromRoom RPC.
	RoomsServiceRemoveUserFromRoomProcedure = "/connectrpc.rooms.v1.RoomsService/RemoveUserFromRoom"
	// RoomsServiceBanUserFromRoomProcedure is the fully-qualified name of the RoomsService's
	// BanUserFromRoom RPC.
	RoomsServiceBanUserFromRoomProcedure = "/connectrpc.rooms.v1.RoomsService/BanUserFromRoom"
	// RoomsServiceUnbanUserFromRoomProcedure is the fully-qualified name of the RoomsService's
	// UnbanUserFromRoom RPC.
	RoomsServiceUnbanUserFromRoomProcedure = "/connectrpc.rooms.v1.RoomsService/UnbanUserFromRoom"
	// RoomsServiceGetBannedUsersFromRoomProcedure is the fully-qualified name of the RoomsService's
	// GetBannedUsersFromRoom RPC.
	RoomsServiceGetBannedUsersFromRoomProcedure = "/connectrpc.rooms.v1.RoomsService/GetBannedUsersFromRoom"
	// RoomsServiceStartMatchProcedure is the fully-qualified name of the RoomsService's StartMatch RPC.
	RoomsServiceStartMatchProcedure = "/connectrpc.rooms.v1.RoomsService/StartMatch"
	// RoomsServiceGetQuestionCountProcedure is the fully-qualified name of the RoomsService's
	// GetQuestionCount RPC.
	RoomsServiceGetQuestionCountProcedure = "/connectrpc.rooms.v1.RoomsService/GetQuestionCount"
	// RoomsServiceGetRoomProcedure is the fully-qualified name of the RoomsService's GetRoom RPC.
	RoomsServiceGetRoomProcedure = "/connectrpc.rooms.v1.RoomsService/GetRoom"
	// RoomsServiceGetUsersInRoomProcedure is the fully-qualified name of the RoomsService's
	// GetUsersInRoom RPC.
	RoomsServiceGetUsersInRoomProcedure = "/connectrpc.rooms.v1.RoomsService/GetUsersInRoom"
	// RoomsServiceCheckIfRoomExistsProcedure is the fully-qualified name of the RoomsService's
	// CheckIfRoomExists RPC.
	RoomsServiceCheckIfRoomExistsProcedure = "/connectrpc.rooms.v1.RoomsService/CheckIfRoomExists"
	// RoomsServiceUserFinishedAnsweringProcedure is the fully-qualified name of the RoomsService's
	// UserFinishedAnswering RPC.
	RoomsServiceUserFinishedAnsweringProcedure = "/connectrpc.rooms.v1.RoomsService/UserFinishedAnswering"
)

// These variables are the protoreflect.Descriptor objects for the RPCs defined in this package.
var (
	roomsServiceServiceDescriptor                      = v1.File_connectrpc_rooms_v1_rooms_proto.Services().ByName("RoomsService")
	roomsServiceCreateRoomMethodDescriptor             = roomsServiceServiceDescriptor.Methods().ByName("CreateRoom")
	roomsServiceEditRoomMethodDescriptor               = roomsServiceServiceDescriptor.Methods().ByName("EditRoom")
	roomsServiceRegisterUserInRoomMethodDescriptor     = roomsServiceServiceDescriptor.Methods().ByName("RegisterUserInRoom")
	roomsServiceRemoveUserFromRoomMethodDescriptor     = roomsServiceServiceDescriptor.Methods().ByName("RemoveUserFromRoom")
	roomsServiceBanUserFromRoomMethodDescriptor        = roomsServiceServiceDescriptor.Methods().ByName("BanUserFromRoom")
	roomsServiceUnbanUserFromRoomMethodDescriptor      = roomsServiceServiceDescriptor.Methods().ByName("UnbanUserFromRoom")
	roomsServiceGetBannedUsersFromRoomMethodDescriptor = roomsServiceServiceDescriptor.Methods().ByName("GetBannedUsersFromRoom")
	roomsServiceStartMatchMethodDescriptor             = roomsServiceServiceDescriptor.Methods().ByName("StartMatch")
	roomsServiceGetQuestionCountMethodDescriptor       = roomsServiceServiceDescriptor.Methods().ByName("GetQuestionCount")
	roomsServiceGetRoomMethodDescriptor                = roomsServiceServiceDescriptor.Methods().ByName("GetRoom")
	roomsServiceGetUsersInRoomMethodDescriptor         = roomsServiceServiceDescriptor.Methods().ByName("GetUsersInRoom")
	roomsServiceCheckIfRoomExistsMethodDescriptor      = roomsServiceServiceDescriptor.Methods().ByName("CheckIfRoomExists")
	roomsServiceUserFinishedAnsweringMethodDescriptor  = roomsServiceServiceDescriptor.Methods().ByName("UserFinishedAnswering")
)

// RoomsServiceClient is a client for the connectrpc.rooms.v1.RoomsService service.
type RoomsServiceClient interface {
	// Creates a room
	CreateRoom(context.Context, *connect.Request[v1.CreateRoomRequest]) (*connect.Response[v1.CreateRoomResponse], error)
	// Edits a room
	EditRoom(context.Context, *connect.Request[v1.EditRoomRequest]) (*connect.Response[v1.EditRoomResponse], error)
	// Add an user to the room's user list
	RegisterUserInRoom(context.Context, *connect.Request[v1.RegisterUserInRoomRequest]) (*connect.Response[v1.RegisterUserInRoomResponse], error)
	// Removes an user from the room's user list
	RemoveUserFromRoom(context.Context, *connect.Request[v1.RemoveUserFromRoomRequest]) (*connect.Response[v1.RemoveUserFromRoomResponse], error)
	// Bans and removes an user from a room
	BanUserFromRoom(context.Context, *connect.Request[v1.BanUserFromRoomRequest]) (*connect.Response[v1.BanUserFromRoomResponse], error)
	// Removes the user from a room's ban list
	UnbanUserFromRoom(context.Context, *connect.Request[v1.UnbanUserFromRoomRequest]) (*connect.Response[v1.UnbanUserFromRoomResponse], error)
	// Gets a room's banned users list
	GetBannedUsersFromRoom(context.Context, *connect.Request[v1.GetBannedUsersFromRoomRequest]) (*connect.Response[v1.GetBannedUsersFromRoomResponse], error)
	// Runs the start match process for a room
	StartMatch(context.Context, *connect.Request[v1.StartMatchRequest]) (*connect.Response[v1.StartMatchResponse], error)
	// Get the number of questions of a room
	GetQuestionCount(context.Context, *connect.Request[v1.GetQuestionCountRequest]) (*connect.Response[v1.GetQuestionCountResponse], error)
	// Gets all the information for a certain room
	GetRoom(context.Context, *connect.Request[v1.GetRoomRequest]) (*connect.Response[v1.GetRoomResponse], error)
	// Get a list of user IDs for a certain room
	GetUsersInRoom(context.Context, *connect.Request[v1.GetUsersInRoomRequest]) (*connect.Response[v1.GetUsersInRoomResponse], error)
	// Checks if a room exists
	CheckIfRoomExists(context.Context, *connect.Request[v1.CheckIfRoomExistsRequest]) (*connect.Response[v1.CheckIfRoomExistsResponse], error)
	// RPC to alert that a user finished answering, used to handle match ends
	UserFinishedAnswering(context.Context, *connect.Request[v1.UserFinishedAnsweringRequest]) (*connect.Response[v1.UserFinishedAnsweringResponse], error)
}

// NewRoomsServiceClient constructs a client for the connectrpc.rooms.v1.RoomsService service. By
// default, it uses the Connect protocol with the binary Protobuf Codec, asks for gzipped responses,
// and sends uncompressed requests. To use the gRPC or gRPC-Web protocols, supply the
// connect.WithGRPC() or connect.WithGRPCWeb() options.
//
// The URL supplied here should be the base URL for the Connect or gRPC server (for example,
// http://api.acme.com or https://acme.com/grpc).
func NewRoomsServiceClient(httpClient connect.HTTPClient, baseURL string, opts ...connect.ClientOption) RoomsServiceClient {
	baseURL = strings.TrimRight(baseURL, "/")
	return &roomsServiceClient{
		createRoom: connect.NewClient[v1.CreateRoomRequest, v1.CreateRoomResponse](
			httpClient,
			baseURL+RoomsServiceCreateRoomProcedure,
			connect.WithSchema(roomsServiceCreateRoomMethodDescriptor),
			connect.WithClientOptions(opts...),
		),
		editRoom: connect.NewClient[v1.EditRoomRequest, v1.EditRoomResponse](
			httpClient,
			baseURL+RoomsServiceEditRoomProcedure,
			connect.WithSchema(roomsServiceEditRoomMethodDescriptor),
			connect.WithClientOptions(opts...),
		),
		registerUserInRoom: connect.NewClient[v1.RegisterUserInRoomRequest, v1.RegisterUserInRoomResponse](
			httpClient,
			baseURL+RoomsServiceRegisterUserInRoomProcedure,
			connect.WithSchema(roomsServiceRegisterUserInRoomMethodDescriptor),
			connect.WithClientOptions(opts...),
		),
		removeUserFromRoom: connect.NewClient[v1.RemoveUserFromRoomRequest, v1.RemoveUserFromRoomResponse](
			httpClient,
			baseURL+RoomsServiceRemoveUserFromRoomProcedure,
			connect.WithSchema(roomsServiceRemoveUserFromRoomMethodDescriptor),
			connect.WithClientOptions(opts...),
		),
		banUserFromRoom: connect.NewClient[v1.BanUserFromRoomRequest, v1.BanUserFromRoomResponse](
			httpClient,
			baseURL+RoomsServiceBanUserFromRoomProcedure,
			connect.WithSchema(roomsServiceBanUserFromRoomMethodDescriptor),
			connect.WithClientOptions(opts...),
		),
		unbanUserFromRoom: connect.NewClient[v1.UnbanUserFromRoomRequest, v1.UnbanUserFromRoomResponse](
			httpClient,
			baseURL+RoomsServiceUnbanUserFromRoomProcedure,
			connect.WithSchema(roomsServiceUnbanUserFromRoomMethodDescriptor),
			connect.WithClientOptions(opts...),
		),
		getBannedUsersFromRoom: connect.NewClient[v1.GetBannedUsersFromRoomRequest, v1.GetBannedUsersFromRoomResponse](
			httpClient,
			baseURL+RoomsServiceGetBannedUsersFromRoomProcedure,
			connect.WithSchema(roomsServiceGetBannedUsersFromRoomMethodDescriptor),
			connect.WithClientOptions(opts...),
		),
		startMatch: connect.NewClient[v1.StartMatchRequest, v1.StartMatchResponse](
			httpClient,
			baseURL+RoomsServiceStartMatchProcedure,
			connect.WithSchema(roomsServiceStartMatchMethodDescriptor),
			connect.WithClientOptions(opts...),
		),
		getQuestionCount: connect.NewClient[v1.GetQuestionCountRequest, v1.GetQuestionCountResponse](
			httpClient,
			baseURL+RoomsServiceGetQuestionCountProcedure,
			connect.WithSchema(roomsServiceGetQuestionCountMethodDescriptor),
			connect.WithClientOptions(opts...),
		),
		getRoom: connect.NewClient[v1.GetRoomRequest, v1.GetRoomResponse](
			httpClient,
			baseURL+RoomsServiceGetRoomProcedure,
			connect.WithSchema(roomsServiceGetRoomMethodDescriptor),
			connect.WithClientOptions(opts...),
		),
		getUsersInRoom: connect.NewClient[v1.GetUsersInRoomRequest, v1.GetUsersInRoomResponse](
			httpClient,
			baseURL+RoomsServiceGetUsersInRoomProcedure,
			connect.WithSchema(roomsServiceGetUsersInRoomMethodDescriptor),
			connect.WithClientOptions(opts...),
		),
		checkIfRoomExists: connect.NewClient[v1.CheckIfRoomExistsRequest, v1.CheckIfRoomExistsResponse](
			httpClient,
			baseURL+RoomsServiceCheckIfRoomExistsProcedure,
			connect.WithSchema(roomsServiceCheckIfRoomExistsMethodDescriptor),
			connect.WithClientOptions(opts...),
		),
		userFinishedAnswering: connect.NewClient[v1.UserFinishedAnsweringRequest, v1.UserFinishedAnsweringResponse](
			httpClient,
			baseURL+RoomsServiceUserFinishedAnsweringProcedure,
			connect.WithSchema(roomsServiceUserFinishedAnsweringMethodDescriptor),
			connect.WithClientOptions(opts...),
		),
	}
}

// roomsServiceClient implements RoomsServiceClient.
type roomsServiceClient struct {
	createRoom             *connect.Client[v1.CreateRoomRequest, v1.CreateRoomResponse]
	editRoom               *connect.Client[v1.EditRoomRequest, v1.EditRoomResponse]
	registerUserInRoom     *connect.Client[v1.RegisterUserInRoomRequest, v1.RegisterUserInRoomResponse]
	removeUserFromRoom     *connect.Client[v1.RemoveUserFromRoomRequest, v1.RemoveUserFromRoomResponse]
	banUserFromRoom        *connect.Client[v1.BanUserFromRoomRequest, v1.BanUserFromRoomResponse]
	unbanUserFromRoom      *connect.Client[v1.UnbanUserFromRoomRequest, v1.UnbanUserFromRoomResponse]
	getBannedUsersFromRoom *connect.Client[v1.GetBannedUsersFromRoomRequest, v1.GetBannedUsersFromRoomResponse]
	startMatch             *connect.Client[v1.StartMatchRequest, v1.StartMatchResponse]
	getQuestionCount       *connect.Client[v1.GetQuestionCountRequest, v1.GetQuestionCountResponse]
	getRoom                *connect.Client[v1.GetRoomRequest, v1.GetRoomResponse]
	getUsersInRoom         *connect.Client[v1.GetUsersInRoomRequest, v1.GetUsersInRoomResponse]
	checkIfRoomExists      *connect.Client[v1.CheckIfRoomExistsRequest, v1.CheckIfRoomExistsResponse]
	userFinishedAnswering  *connect.Client[v1.UserFinishedAnsweringRequest, v1.UserFinishedAnsweringResponse]
}

// CreateRoom calls connectrpc.rooms.v1.RoomsService.CreateRoom.
func (c *roomsServiceClient) CreateRoom(ctx context.Context, req *connect.Request[v1.CreateRoomRequest]) (*connect.Response[v1.CreateRoomResponse], error) {
	return c.createRoom.CallUnary(ctx, req)
}

// EditRoom calls connectrpc.rooms.v1.RoomsService.EditRoom.
func (c *roomsServiceClient) EditRoom(ctx context.Context, req *connect.Request[v1.EditRoomRequest]) (*connect.Response[v1.EditRoomResponse], error) {
	return c.editRoom.CallUnary(ctx, req)
}

// RegisterUserInRoom calls connectrpc.rooms.v1.RoomsService.RegisterUserInRoom.
func (c *roomsServiceClient) RegisterUserInRoom(ctx context.Context, req *connect.Request[v1.RegisterUserInRoomRequest]) (*connect.Response[v1.RegisterUserInRoomResponse], error) {
	return c.registerUserInRoom.CallUnary(ctx, req)
}

// RemoveUserFromRoom calls connectrpc.rooms.v1.RoomsService.RemoveUserFromRoom.
func (c *roomsServiceClient) RemoveUserFromRoom(ctx context.Context, req *connect.Request[v1.RemoveUserFromRoomRequest]) (*connect.Response[v1.RemoveUserFromRoomResponse], error) {
	return c.removeUserFromRoom.CallUnary(ctx, req)
}

// BanUserFromRoom calls connectrpc.rooms.v1.RoomsService.BanUserFromRoom.
func (c *roomsServiceClient) BanUserFromRoom(ctx context.Context, req *connect.Request[v1.BanUserFromRoomRequest]) (*connect.Response[v1.BanUserFromRoomResponse], error) {
	return c.banUserFromRoom.CallUnary(ctx, req)
}

// UnbanUserFromRoom calls connectrpc.rooms.v1.RoomsService.UnbanUserFromRoom.
func (c *roomsServiceClient) UnbanUserFromRoom(ctx context.Context, req *connect.Request[v1.UnbanUserFromRoomRequest]) (*connect.Response[v1.UnbanUserFromRoomResponse], error) {
	return c.unbanUserFromRoom.CallUnary(ctx, req)
}

// GetBannedUsersFromRoom calls connectrpc.rooms.v1.RoomsService.GetBannedUsersFromRoom.
func (c *roomsServiceClient) GetBannedUsersFromRoom(ctx context.Context, req *connect.Request[v1.GetBannedUsersFromRoomRequest]) (*connect.Response[v1.GetBannedUsersFromRoomResponse], error) {
	return c.getBannedUsersFromRoom.CallUnary(ctx, req)
}

// StartMatch calls connectrpc.rooms.v1.RoomsService.StartMatch.
func (c *roomsServiceClient) StartMatch(ctx context.Context, req *connect.Request[v1.StartMatchRequest]) (*connect.Response[v1.StartMatchResponse], error) {
	return c.startMatch.CallUnary(ctx, req)
}

// GetQuestionCount calls connectrpc.rooms.v1.RoomsService.GetQuestionCount.
func (c *roomsServiceClient) GetQuestionCount(ctx context.Context, req *connect.Request[v1.GetQuestionCountRequest]) (*connect.Response[v1.GetQuestionCountResponse], error) {
	return c.getQuestionCount.CallUnary(ctx, req)
}

// GetRoom calls connectrpc.rooms.v1.RoomsService.GetRoom.
func (c *roomsServiceClient) GetRoom(ctx context.Context, req *connect.Request[v1.GetRoomRequest]) (*connect.Response[v1.GetRoomResponse], error) {
	return c.getRoom.CallUnary(ctx, req)
}

// GetUsersInRoom calls connectrpc.rooms.v1.RoomsService.GetUsersInRoom.
func (c *roomsServiceClient) GetUsersInRoom(ctx context.Context, req *connect.Request[v1.GetUsersInRoomRequest]) (*connect.Response[v1.GetUsersInRoomResponse], error) {
	return c.getUsersInRoom.CallUnary(ctx, req)
}

// CheckIfRoomExists calls connectrpc.rooms.v1.RoomsService.CheckIfRoomExists.
func (c *roomsServiceClient) CheckIfRoomExists(ctx context.Context, req *connect.Request[v1.CheckIfRoomExistsRequest]) (*connect.Response[v1.CheckIfRoomExistsResponse], error) {
	return c.checkIfRoomExists.CallUnary(ctx, req)
}

// UserFinishedAnswering calls connectrpc.rooms.v1.RoomsService.UserFinishedAnswering.
func (c *roomsServiceClient) UserFinishedAnswering(ctx context.Context, req *connect.Request[v1.UserFinishedAnsweringRequest]) (*connect.Response[v1.UserFinishedAnsweringResponse], error) {
	return c.userFinishedAnswering.CallUnary(ctx, req)
}

// RoomsServiceHandler is an implementation of the connectrpc.rooms.v1.RoomsService service.
type RoomsServiceHandler interface {
	// Creates a room
	CreateRoom(context.Context, *connect.Request[v1.CreateRoomRequest]) (*connect.Response[v1.CreateRoomResponse], error)
	// Edits a room
	EditRoom(context.Context, *connect.Request[v1.EditRoomRequest]) (*connect.Response[v1.EditRoomResponse], error)
	// Add an user to the room's user list
	RegisterUserInRoom(context.Context, *connect.Request[v1.RegisterUserInRoomRequest]) (*connect.Response[v1.RegisterUserInRoomResponse], error)
	// Removes an user from the room's user list
	RemoveUserFromRoom(context.Context, *connect.Request[v1.RemoveUserFromRoomRequest]) (*connect.Response[v1.RemoveUserFromRoomResponse], error)
	// Bans and removes an user from a room
	BanUserFromRoom(context.Context, *connect.Request[v1.BanUserFromRoomRequest]) (*connect.Response[v1.BanUserFromRoomResponse], error)
	// Removes the user from a room's ban list
	UnbanUserFromRoom(context.Context, *connect.Request[v1.UnbanUserFromRoomRequest]) (*connect.Response[v1.UnbanUserFromRoomResponse], error)
	// Gets a room's banned users list
	GetBannedUsersFromRoom(context.Context, *connect.Request[v1.GetBannedUsersFromRoomRequest]) (*connect.Response[v1.GetBannedUsersFromRoomResponse], error)
	// Runs the start match process for a room
	StartMatch(context.Context, *connect.Request[v1.StartMatchRequest]) (*connect.Response[v1.StartMatchResponse], error)
	// Get the number of questions of a room
	GetQuestionCount(context.Context, *connect.Request[v1.GetQuestionCountRequest]) (*connect.Response[v1.GetQuestionCountResponse], error)
	// Gets all the information for a certain room
	GetRoom(context.Context, *connect.Request[v1.GetRoomRequest]) (*connect.Response[v1.GetRoomResponse], error)
	// Get a list of user IDs for a certain room
	GetUsersInRoom(context.Context, *connect.Request[v1.GetUsersInRoomRequest]) (*connect.Response[v1.GetUsersInRoomResponse], error)
	// Checks if a room exists
	CheckIfRoomExists(context.Context, *connect.Request[v1.CheckIfRoomExistsRequest]) (*connect.Response[v1.CheckIfRoomExistsResponse], error)
	// RPC to alert that a user finished answering, used to handle match ends
	UserFinishedAnswering(context.Context, *connect.Request[v1.UserFinishedAnsweringRequest]) (*connect.Response[v1.UserFinishedAnsweringResponse], error)
}

// NewRoomsServiceHandler builds an HTTP handler from the service implementation. It returns the
// path on which to mount the handler and the handler itself.
//
// By default, handlers support the Connect, gRPC, and gRPC-Web protocols with the binary Protobuf
// and JSON codecs. They also support gzip compression.
func NewRoomsServiceHandler(svc RoomsServiceHandler, opts ...connect.HandlerOption) (string, http.Handler) {
	roomsServiceCreateRoomHandler := connect.NewUnaryHandler(
		RoomsServiceCreateRoomProcedure,
		svc.CreateRoom,
		connect.WithSchema(roomsServiceCreateRoomMethodDescriptor),
		connect.WithHandlerOptions(opts...),
	)
	roomsServiceEditRoomHandler := connect.NewUnaryHandler(
		RoomsServiceEditRoomProcedure,
		svc.EditRoom,
		connect.WithSchema(roomsServiceEditRoomMethodDescriptor),
		connect.WithHandlerOptions(opts...),
	)
	roomsServiceRegisterUserInRoomHandler := connect.NewUnaryHandler(
		RoomsServiceRegisterUserInRoomProcedure,
		svc.RegisterUserInRoom,
		connect.WithSchema(roomsServiceRegisterUserInRoomMethodDescriptor),
		connect.WithHandlerOptions(opts...),
	)
	roomsServiceRemoveUserFromRoomHandler := connect.NewUnaryHandler(
		RoomsServiceRemoveUserFromRoomProcedure,
		svc.RemoveUserFromRoom,
		connect.WithSchema(roomsServiceRemoveUserFromRoomMethodDescriptor),
		connect.WithHandlerOptions(opts...),
	)
	roomsServiceBanUserFromRoomHandler := connect.NewUnaryHandler(
		RoomsServiceBanUserFromRoomProcedure,
		svc.BanUserFromRoom,
		connect.WithSchema(roomsServiceBanUserFromRoomMethodDescriptor),
		connect.WithHandlerOptions(opts...),
	)
	roomsServiceUnbanUserFromRoomHandler := connect.NewUnaryHandler(
		RoomsServiceUnbanUserFromRoomProcedure,
		svc.UnbanUserFromRoom,
		connect.WithSchema(roomsServiceUnbanUserFromRoomMethodDescriptor),
		connect.WithHandlerOptions(opts...),
	)
	roomsServiceGetBannedUsersFromRoomHandler := connect.NewUnaryHandler(
		RoomsServiceGetBannedUsersFromRoomProcedure,
		svc.GetBannedUsersFromRoom,
		connect.WithSchema(roomsServiceGetBannedUsersFromRoomMethodDescriptor),
		connect.WithHandlerOptions(opts...),
	)
	roomsServiceStartMatchHandler := connect.NewUnaryHandler(
		RoomsServiceStartMatchProcedure,
		svc.StartMatch,
		connect.WithSchema(roomsServiceStartMatchMethodDescriptor),
		connect.WithHandlerOptions(opts...),
	)
	roomsServiceGetQuestionCountHandler := connect.NewUnaryHandler(
		RoomsServiceGetQuestionCountProcedure,
		svc.GetQuestionCount,
		connect.WithSchema(roomsServiceGetQuestionCountMethodDescriptor),
		connect.WithHandlerOptions(opts...),
	)
	roomsServiceGetRoomHandler := connect.NewUnaryHandler(
		RoomsServiceGetRoomProcedure,
		svc.GetRoom,
		connect.WithSchema(roomsServiceGetRoomMethodDescriptor),
		connect.WithHandlerOptions(opts...),
	)
	roomsServiceGetUsersInRoomHandler := connect.NewUnaryHandler(
		RoomsServiceGetUsersInRoomProcedure,
		svc.GetUsersInRoom,
		connect.WithSchema(roomsServiceGetUsersInRoomMethodDescriptor),
		connect.WithHandlerOptions(opts...),
	)
	roomsServiceCheckIfRoomExistsHandler := connect.NewUnaryHandler(
		RoomsServiceCheckIfRoomExistsProcedure,
		svc.CheckIfRoomExists,
		connect.WithSchema(roomsServiceCheckIfRoomExistsMethodDescriptor),
		connect.WithHandlerOptions(opts...),
	)
	roomsServiceUserFinishedAnsweringHandler := connect.NewUnaryHandler(
		RoomsServiceUserFinishedAnsweringProcedure,
		svc.UserFinishedAnswering,
		connect.WithSchema(roomsServiceUserFinishedAnsweringMethodDescriptor),
		connect.WithHandlerOptions(opts...),
	)
	return "/connectrpc.rooms.v1.RoomsService/", http.HandlerFunc(func(w http.ResponseWriter, r *http.Request) {
		switch r.URL.Path {
		case RoomsServiceCreateRoomProcedure:
			roomsServiceCreateRoomHandler.ServeHTTP(w, r)
		case RoomsServiceEditRoomProcedure:
			roomsServiceEditRoomHandler.ServeHTTP(w, r)
		case RoomsServiceRegisterUserInRoomProcedure:
			roomsServiceRegisterUserInRoomHandler.ServeHTTP(w, r)
		case RoomsServiceRemoveUserFromRoomProcedure:
			roomsServiceRemoveUserFromRoomHandler.ServeHTTP(w, r)
		case RoomsServiceBanUserFromRoomProcedure:
			roomsServiceBanUserFromRoomHandler.ServeHTTP(w, r)
		case RoomsServiceUnbanUserFromRoomProcedure:
			roomsServiceUnbanUserFromRoomHandler.ServeHTTP(w, r)
		case RoomsServiceGetBannedUsersFromRoomProcedure:
			roomsServiceGetBannedUsersFromRoomHandler.ServeHTTP(w, r)
		case RoomsServiceStartMatchProcedure:
			roomsServiceStartMatchHandler.ServeHTTP(w, r)
		case RoomsServiceGetQuestionCountProcedure:
			roomsServiceGetQuestionCountHandler.ServeHTTP(w, r)
		case RoomsServiceGetRoomProcedure:
			roomsServiceGetRoomHandler.ServeHTTP(w, r)
		case RoomsServiceGetUsersInRoomProcedure:
			roomsServiceGetUsersInRoomHandler.ServeHTTP(w, r)
		case RoomsServiceCheckIfRoomExistsProcedure:
			roomsServiceCheckIfRoomExistsHandler.ServeHTTP(w, r)
		case RoomsServiceUserFinishedAnsweringProcedure:
			roomsServiceUserFinishedAnsweringHandler.ServeHTTP(w, r)
		default:
			http.NotFound(w, r)
		}
	})
}

// UnimplementedRoomsServiceHandler returns CodeUnimplemented from all methods.
type UnimplementedRoomsServiceHandler struct{}

func (UnimplementedRoomsServiceHandler) CreateRoom(context.Context, *connect.Request[v1.CreateRoomRequest]) (*connect.Response[v1.CreateRoomResponse], error) {
	return nil, connect.NewError(connect.CodeUnimplemented, errors.New("connectrpc.rooms.v1.RoomsService.CreateRoom is not implemented"))
}

func (UnimplementedRoomsServiceHandler) EditRoom(context.Context, *connect.Request[v1.EditRoomRequest]) (*connect.Response[v1.EditRoomResponse], error) {
	return nil, connect.NewError(connect.CodeUnimplemented, errors.New("connectrpc.rooms.v1.RoomsService.EditRoom is not implemented"))
}

func (UnimplementedRoomsServiceHandler) RegisterUserInRoom(context.Context, *connect.Request[v1.RegisterUserInRoomRequest]) (*connect.Response[v1.RegisterUserInRoomResponse], error) {
	return nil, connect.NewError(connect.CodeUnimplemented, errors.New("connectrpc.rooms.v1.RoomsService.RegisterUserInRoom is not implemented"))
}

func (UnimplementedRoomsServiceHandler) RemoveUserFromRoom(context.Context, *connect.Request[v1.RemoveUserFromRoomRequest]) (*connect.Response[v1.RemoveUserFromRoomResponse], error) {
	return nil, connect.NewError(connect.CodeUnimplemented, errors.New("connectrpc.rooms.v1.RoomsService.RemoveUserFromRoom is not implemented"))
}

func (UnimplementedRoomsServiceHandler) BanUserFromRoom(context.Context, *connect.Request[v1.BanUserFromRoomRequest]) (*connect.Response[v1.BanUserFromRoomResponse], error) {
	return nil, connect.NewError(connect.CodeUnimplemented, errors.New("connectrpc.rooms.v1.RoomsService.BanUserFromRoom is not implemented"))
}

func (UnimplementedRoomsServiceHandler) UnbanUserFromRoom(context.Context, *connect.Request[v1.UnbanUserFromRoomRequest]) (*connect.Response[v1.UnbanUserFromRoomResponse], error) {
	return nil, connect.NewError(connect.CodeUnimplemented, errors.New("connectrpc.rooms.v1.RoomsService.UnbanUserFromRoom is not implemented"))
}

func (UnimplementedRoomsServiceHandler) GetBannedUsersFromRoom(context.Context, *connect.Request[v1.GetBannedUsersFromRoomRequest]) (*connect.Response[v1.GetBannedUsersFromRoomResponse], error) {
	return nil, connect.NewError(connect.CodeUnimplemented, errors.New("connectrpc.rooms.v1.RoomsService.GetBannedUsersFromRoom is not implemented"))
}

func (UnimplementedRoomsServiceHandler) StartMatch(context.Context, *connect.Request[v1.StartMatchRequest]) (*connect.Response[v1.StartMatchResponse], error) {
	return nil, connect.NewError(connect.CodeUnimplemented, errors.New("connectrpc.rooms.v1.RoomsService.StartMatch is not implemented"))
}

func (UnimplementedRoomsServiceHandler) GetQuestionCount(context.Context, *connect.Request[v1.GetQuestionCountRequest]) (*connect.Response[v1.GetQuestionCountResponse], error) {
	return nil, connect.NewError(connect.CodeUnimplemented, errors.New("connectrpc.rooms.v1.RoomsService.GetQuestionCount is not implemented"))
}

func (UnimplementedRoomsServiceHandler) GetRoom(context.Context, *connect.Request[v1.GetRoomRequest]) (*connect.Response[v1.GetRoomResponse], error) {
	return nil, connect.NewError(connect.CodeUnimplemented, errors.New("connectrpc.rooms.v1.RoomsService.GetRoom is not implemented"))
}

func (UnimplementedRoomsServiceHandler) GetUsersInRoom(context.Context, *connect.Request[v1.GetUsersInRoomRequest]) (*connect.Response[v1.GetUsersInRoomResponse], error) {
	return nil, connect.NewError(connect.CodeUnimplemented, errors.New("connectrpc.rooms.v1.RoomsService.GetUsersInRoom is not implemented"))
}

func (UnimplementedRoomsServiceHandler) CheckIfRoomExists(context.Context, *connect.Request[v1.CheckIfRoomExistsRequest]) (*connect.Response[v1.CheckIfRoomExistsResponse], error) {
	return nil, connect.NewError(connect.CodeUnimplemented, errors.New("connectrpc.rooms.v1.RoomsService.CheckIfRoomExists is not implemented"))
}

func (UnimplementedRoomsServiceHandler) UserFinishedAnswering(context.Context, *connect.Request[v1.UserFinishedAnsweringRequest]) (*connect.Response[v1.UserFinishedAnsweringResponse], error) {
	return nil, connect.NewError(connect.CodeUnimplemented, errors.New("connectrpc.rooms.v1.RoomsService.UserFinishedAnswering is not implemented"))
}
